var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { useEffect, useRef, useState } from 'react';
import { getClassName } from '@react-devui/utils';
import { registerComponentMate } from '../../utils';
import { useComponentConfig, usePrefixConfig } from '../root';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DAvatar' });
export function DAvatar(props) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { dVariant = 'circular', dImg, dIcon, dText, dSize = 40 } = _a, restProps = __rest(_a, ["dVariant", "dImg", "dIcon", "dText", "dSize"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    //#region Ref
    const textRef = useRef(null);
    //#endregion
    const [imgError, setImgError] = useState(false);
    const type = dImg && !imgError ? 'img' : dIcon ? 'icon' : dText ? 'text' : 'img';
    useEffect(() => {
        if (textRef.current) {
            const maxWidth = Math.sqrt(Math.pow(dSize / 2, 2) - Math.pow(textRef.current.scrollHeight / 2, 2)) * 2;
            if (textRef.current.scrollWidth > maxWidth) {
                textRef.current.style.transform = `scale(${maxWidth / textRef.current.scrollWidth})`;
            }
            else {
                textRef.current.style.transform = '';
            }
        }
    });
    return (_jsx("div", Object.assign({}, restProps, { className: getClassName(restProps.className, `${dPrefix}avatar`, `${dPrefix}avatar--${type}`, `${dPrefix}avatar--${dVariant}`), style: Object.assign(Object.assign({}, restProps.style), { width: dSize, height: dSize, fontSize: type === 'icon' ? dSize / 2 : type === 'text' ? dSize * 0.45 : undefined }) }, { children: type === 'img' ? (
        // eslint-disable-next-line jsx-a11y/alt-text
        _jsx("img", Object.assign({}, dImg, { className: getClassName(dImg === null || dImg === void 0 ? void 0 : dImg.className, `${dPrefix}avatar__img`), onError: (e) => {
                var _a;
                (_a = dImg === null || dImg === void 0 ? void 0 : dImg.onError) === null || _a === void 0 ? void 0 : _a.call(dImg, e);
                setImgError(true);
            } }))) : type === 'icon' ? (dIcon) : (_jsx("div", Object.assign({ ref: textRef }, { children: dText }))) })));
}
